% function [w_0 v_t b_t alpha mu] = evanGetW(dataFile,resultFile,sp)

% load(dataFile);
% load(resultFile);
sp =1;

mids = sort(unique(data.ftasks))';
T = length(mids);
mu = bestCvParameter(1,sp);
split = splits{sp};
trainInd = cell(T,1);
testInd = cell(T,1);
xTrain = cell(T,1);
xTest = cell(T,1);
yTrain = cell(T,1);
yTest = cell(T,1);

numTrain = split.numTrain;
xTrainArr = [];
numTest = split.numTest;
for t=1:T
    trainInd{t} = split.train( (sum(numTrain(1:(t-1)))+1):sum(numTrain(1:t)) );
    testInd{t} = split.test( (sum(numTest(1:(t-1)))+1):sum(numTest(1:t)) );
    xTrain{t} = data.fdata(trainInd{t},:)';
    xTest{t} = data.fdata(testInd{t},:)';
    yTrain{t} = data.flabels(trainInd{t});
    yTest{t} = data.flabels(testInd{t});
    xTrainArr = [xTrainArr,xTrain{t}];
end

alpha = fhtl{sp}.outputs{1}.alphaStruct;
b_t = fhtl{sp}.outputs{1}.b_t;
% w_0 = xTrainArr*alpha/mu;
v_t = [];
for t=1:T
    temp = xTrain{t}*alpha((sum(numTrain(1:(t-1)))+1):sum(numTrain(1:t)));
    v_t = [v_t, temp];
end

n = sum(numTrain);
begIdx = [1;cumsum(numTrain(1:end-1))+1];
endIdx = cumsum(numTrain(1:end));
hull = fhtl{sp}.outputs{1}.data_hull.hull;
p = size(hull,1);
nodeIdx = logical([]);
toAdd = false(n,size(hull,1));
taskDenoter = 2;
for t=1:T
    presentNodes = hull(:,t)==taskDenoter;
    toAdd(begIdx(t):endIdx(t),presentNodes) = true;
end
nodeIdx = [nodeIdx, toAdd];

zeta = fhtl{sp}.outputs{1}.zeta_hull;
theta = fhtl{sp}.outputs{1}.theta_hull;
theta_zeta = theta.*zeta;

d = size(xTrainArr,1);
V1 = zeros(d,T+1,p);
V2 = zeros(d,T,p);
for i=1:p
    presentTasks = find(hull(i,:)==taskDenoter);
    temp = zeros(d,1);
    for t=presentTasks
        V1(:,t+1,i) = theta_zeta(i)*v_t(:,t);%xTrain{t}*alpha((sum(numTrain(1:(t-1)))+1):sum(numTrain(1:t)));
        temp = temp + V1(:,t+1,i);
    end
    if length(presentTasks)==1
        V1(:,1,i) = zeros(d,1);
        for t=presentTasks
            V2(:,t,i) = V1(:,1,i) + V1(:,t+1,i);
        end
    else
        V1(:,1,i) = temp/mu;
        for t=presentTasks
            V2(:,t,i) = V1(:,1,i) + V1(:,t+1,i);
        end
    end
end

W = zeros(d,T);
YPred = cell(T,1);
nmse = 0;
for t=1:T
    presentNodes = find(hull(:,t)==taskDenoter);
    temp = zeros(d,1);
    for i=presentNodes'
        temp = temp + V2(:,t,i);
    end
    W(:,t) = temp;
%     YPred{t} = xTest{t}'*W(:,t) + b_t(t);
%     nmse = nmse + calculateErr(YPred{t}, yTest{t},'amse');
    % predict YTest
end



% W = [w_0 v_t];
% W_t = repmat(w_0,1,T) + v_t;
% keyboard;
